## hhsuite 2.0.13

=== Makefile ===
# This can be overridden e.g.: make install INSTALL_DIR=...
INSTALL_DIR?=$(PWD)

# Guess wether to use lib or lib64
#libdir=`([ -d /usr/lib64 ] && echo lib64) || echo lib`
# We don't have platform specific lib stuff
libdir=lib

# Overriding this is currently not fully supported as the code won't know
# to what this is set then. You can try setting HHLIB.
INSTALL_LIB_DIR?=$(INSTALL_DIR)/$(libdir)/hh
INSTALL_SCRIPTS_DIR?=$(INSTALL_LIB_DIR)/scripts
INSTALL_DATA_DIR?=$(INSTALL_LIB_DIR)/data
INSTALL_LIB_BIN_DIR?=$(INSTALL_LIB_DIR)/bin

dist_name=hhsuite-2.0.13

.PHONY: all_static
all_static: ffindex_static
	$(MAKE) -C src all_static

.PHONY: all
all: ffindex
	$(MAKE) -C src all

doc:
	$(MAKE) -C src hhsuite-userguide.pdf

hhblits_static: hhblits_static
	$(MAKE) -C src hhblits_static

hhblits: ffindex
	$(MAKE) -C src all

.PHONY: ffindex
ffindex:
	$(MAKE) -C lib/ffindex

ffindex_static:
	$(MAKE) -C lib/ffindex FFINDEX_STATIC=1
	
install:
	$(MAKE) -C lib/ffindex install INSTALL_DIR=$(INSTALL_DIR)
	mkdir -p $(INSTALL_DIR)/bin
	install src/hhblits     $(INSTALL_DIR)/bin/hhblits
	install src/hhalign     $(INSTALL_DIR)/bin/hhalign
	install src/hhconsensus $(INSTALL_DIR)/bin/hhconsensus
	install src/hhfilter    $(INSTALL_DIR)/bin/hhfilter
	install src/hhmake      $(INSTALL_DIR)/bin/hhmake
	install src/hhsearch    $(INSTALL_DIR)/bin/hhsearch
	mkdir -p $(INSTALL_LIB_DIR)
	mkdir -p $(INSTALL_LIB_BIN_DIR)
	install src/cstranslate $(INSTALL_LIB_BIN_DIR)/cstranslate
	mkdir -p $(INSTALL_DATA_DIR)
	install -m 0644 data/context_data.lib $(INSTALL_DATA_DIR)/context_data.lib
	install -m 0644 data/cs219.lib        $(INSTALL_DATA_DIR)/cs219.lib
	install -m 0644 data/do_not_delete    $(INSTALL_DATA_DIR)/do_not_delete
	install -m 0644 data/do_not_delete.phr $(INSTALL_DATA_DIR)/do_not_delete.phr
	install -m 0644 data/do_not_delete.pin $(INSTALL_DATA_DIR)/do_not_delete.pin
	install -m 0644 data/do_not_delete.psq $(INSTALL_DATA_DIR)/do_not_delete.psq
	mkdir -p $(INSTALL_SCRIPTS_DIR)
	install -m 0644 scripts/Align.pm        $(INSTALL_SCRIPTS_DIR)/Align.pm
	install -m 0644 scripts/HHPaths.pm      $(INSTALL_SCRIPTS_DIR)/HHPaths.pm
	install scripts/addss.pl        $(INSTALL_SCRIPTS_DIR)/addss.pl
	install scripts/create_profile_from_hhm.pl   $(INSTALL_SCRIPTS_DIR)/create_profile_from_hhm.pl
	install scripts/create_profile_from_hmmer.pl $(INSTALL_SCRIPTS_DIR)/create_profile_from_hmmer.pl
	install scripts/hhmakemodel.pl $(INSTALL_SCRIPTS_DIR)/hhmakemodel.pl
	install scripts/reformat.pl    $(INSTALL_SCRIPTS_DIR)/reformat.pl
	install scripts/splitfasta.pl    $(INSTALL_SCRIPTS_DIR)/splitfasta.pl
	install scripts/multithread.pl    $(INSTALL_SCRIPTS_DIR)/multithread.pl
	install scripts/hhblitsdb.pl    $(INSTALL_SCRIPTS_DIR)/hhblitsdb.pl

deinstall:
	$(MAKE) -C lib/ffindex deinstall INSTALL_DIR=$(INSTALL_DIR)
	rm -f $(INSTALL_DIR)/bin/hhblits $(INSTALL_DIR)/bin/hhalign \
		$(INSTALL_DIR)/bin/hhconsensus $(INSTALL_DIR)/bin/hhfilter $(INSTALL_DIR)/bin/hhmake $(INSTALL_DIR)/bin/hhsearch
	rm -f $(INSTALL_DATA_DIR)/context_data.lib $(INSTALL_DATA_DIR)/cs219.lib $(INSTALL_DATA_DIR)/do_not_delete \
		$(INSTALL_DATA_DIR)/do_not_delete.phr $(INSTALL_DATA_DIR)/do_not_delete.pin $(INSTALL_DATA_DIR)/do_not_delete.psq
	rm -f $(INSTALL_SCRIPTS_DIR)/Align.pm $(INSTALL_SCRIPTS_DIR)/HHPaths.pm $(INSTALL_SCRIPTS_DIR)/splitfasta.pl \
		$(INSTALL_SCRIPTS_DIR)/addss.pl $(INSTALL_SCRIPTS_DIR)/create_profile_from_hhm.pl \
		$(INSTALL_SCRIPTS_DIR)/create_profile_from_hmmer.pl $(INSTALL_SCRIPTS_DIR)/hhmakemodel.pl \
		$(INSTALL_SCRIPTS_DIR)/reformat.pl $(INSTALL_SCRIPTS_DIR)/multithread.pl $(INSTALL_SCRIPTS_DIR)/hhblitsdb.pl
	rm -f $(INSTALL_LIB_BIN_DIR)/cstranslate 
	rmdir $(INSTALL_LIB_BIN_DIR) || true
	rmdir $(INSTALL_DIR)/bin || true
	rmdir $(INSTALL_DATA_DIR) || true
	rmdir $(INSTALL_SCRIPTS_DIR) || true
	rmdir $(INSTALL_LIB_DIR) || true

.PHONY: clean
clean:
	cd lib/ffindex && $(MAKE) clean
	$(MAKE) -C src clean

dist/$(dist_name).tar.gz:
	make clean
	mkdir -p dist
	git archive --prefix=$(dist_name)/ -o dist/$(dist_name).tar.gz HEAD
	cd dist && tar xf $(dist_name).tar.gz
	mkdir -p dist/$(dist_name)/bin
	cd dist/$(dist_name) && rsync --exclude .git --exclude .hg -av ../../lib .
	cd dist && tar czf $(dist_name).tar.gz $(dist_name)

=== src/Makefile ===
CS_DIR = cs
FFINDEX_DIR?=../lib/ffindex/src

OS:= $(shell uname)

# Convert BITS=?? to a -m flag
BITS_FLAG =
ifeq (32,$(BITS))
 BITS_FLAG = -m32
endif
ifeq (64,$(BITS))
 BITS_FLAG = -m64
endif

ifdef ICC
  CXX = env LANG=C icc
  CXXFLAGS = -fast -Wall -fno-strict-aliasing -finline-functions -funroll-loops -fp-model fast=2 -fast-transcendentals -wd981 -wd383 -wd2259 -wd1572 -D HH_SSE3 -I$(CS_DIR) -I$(FFINDEX_DIR)
  HHSEARCH_LIBS = -lpthread -lrt
  HHBLITS_LIBS = -lpthread -lrt -openmp
  OBJECT_LIBS = -openmp
else # ifndef ICC
  CXX = g++
  CXXFLAGS = -O3 -Wall -Wno-deprecated -Wno-char-subscripts -fno-strict-aliasing -I$(CS_DIR) $(BITS_FLAG) -I$(FFINDEX_DIR)
  HHSEARCH_LIBS = -lpthread
  HHBLITS_LIBS = -lpthread -fopenmp
  HHALIGN_LIBS = 
  OBJECT_LIBS = -fopenmp
  ifdef WITH_NATIVE
    CXXFLAGS += -march=native
  endif
  ifdef WITH_SSE41
    CXXFLAGS += -DHH_SSE41 -msse4.1 -DHH_SSSE3 -mssse3
  else
    ifndef NO_SSE2
      ifdef NO_SSE3
        CXXFLAGS += -DHH_SSE2 -msse2
      else
        CXXFLAGS += -DHH_SSE3 -msse3
      endif
    endif
  endif
  ifeq ($(OS), Darwin)
    CXXFLAGS+=-DHH_MAC
  endif
  ifeq ($(OS), Linux)
    HHSEARCH_LIBS = -lpthread -lrt
    HHBLITS_LIBS+=-lrt
    ifndef NO_PNG
      HHALIGN_LIBS = -DNO_FREETYPE -DHH_PNG -lpng -lz
    endif
  endif
endif # ifndef ICC

CPP = $(CXX) $(CXXFLAGS)
CPP_VALGRIND = $(CXX) -g $(CXXFLAGS)


SOURCES = hhsearch.C hhhitlist.C hhhit.C hhalignment.C hhhmm.C hhmatrices.C hhdecl.C hhfunc.C hhprefilter.C hhworker.C hhfullalignment.C hhhalfalignment.C hhutil.C util.C hash.C list.C

CS_SOURCES_WITH_APPS = $(filter-out $(wildcard $(CS_DIR)/*test*.cc), $(wildcard $(CS_DIR)/*.cc))
CS_SOURCES = $(filter-out $(wildcard $(CS_DIR)/*app.cc), $(CS_SOURCES_WITH_APPS))
CS_OBJECTS = $(patsubst %.cc, %.o, $(CS_SOURCES))

HEADERS = hhhitlist.h hhhit.h hhalignment.h hhhmm.h hhfullalignment.h hhfullalignment.h hash.h list.h

TARGETS = hhblits hhsearch hhmake hhalign hhfilter hhconsensus cstranslate
TARGETS_STATIC = hhblits_static hhsearch_static hhmake_static hhalign_static hhfilter_static hhconsensus_static cstranslate_static
TARGETS_VALGRIND = hhblits_valgrind hhsearch_valgrind hhalign_valgrind

all: $(TARGETS)

all_static: $(TARGETS_STATIC)

all_valgrind: $(TARGETS_VALGRIND)

$(CS_OBJECTS): $(CS_DIR)/%.o: $(CS_DIR)/%.cc
	$(CPP) $(OBJECT_LIBS) -c $< -o $@

cstranslate: $(CS_DIR)/cstranslate_app.cc $(CS_OBJECTS)
	$(CPP) -lm -o cstranslate $(CS_DIR)/cstranslate_app.cc $(CS_OBJECTS)

cstranslate_static: $(CS_DIR)/cstranslate_app.cc $(CS_OBJECTS)
	$(CPP) -static -lm -o cstranslate $(CS_DIR)/cstranslate_app.cc $(CS_OBJECTS)

hhsearch: hhsearch.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)
	 $(CPP) hhsearch.C -o hhsearch $(CS_OBJECTS) $(HHSEARCH_LIBS)

hhsearch_static: hhsearch.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)
	 $(CPP) -static hhsearch.C -o hhsearch $(CS_OBJECTS) $(HHSEARCH_LIBS)

hhsearch_valgrind: hhsearch.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)
	  $(CPP_VALGRIND) hhsearch.C -o hhsearch_valgrind $(CS_OBJECTS) $(HHSEARCH_LIBS)

hhblits: hhblits.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)
	 $(CPP) hhblits.C -o hhblits $(CS_OBJECTS) $(HHBLITS_LIBS) $(FFINDEX_DIR)/libffindex.a

hhblits_static: hhblits.C $(SOURCES) $(HEADERS)$(CS_OBJECTS)
	 $(CPP) -static hhblits.C -o hhblits $(CS_OBJECTS) $(HHBLITS_LIBS) $(FFINDEX_DIR)/libffindex.a

hhblits_valgrind: hhblits.C $(SOURCES) $(HEADERS)$(CS_OBJECTS)
	  $(CPP_VALGRIND) hhblits.C -o hhblits_valgrind $(CS_OBJECTS) $(HHBLITS_LIBS) $(FFINDEX_DIR)/libffindex.a

hhmake: hhmake.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)
	$(CPP) hhmake.C -o hhmake $(CS_OBJECTS)

hhmake_static: hhmake.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)
	$(CPP) -static hhmake.C -o hhmake $(CS_OBJECTS)

hhalign: hhalign.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)
	 $(CPP) hhalign.C -o hhalign $(CS_OBJECTS) $(HHALIGN_LIBS)

hhalign_static: hhalign.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)
	 $(CPP) -static hhalign.C -o hhalign $(CS_OBJECTS) $(HHALIGN_LIBS)

hhalign_valgrind: hhalign.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)
	  $(CPP_VALGRIND) hhalign.C -o hhalign_valgrind $(CS_OBJECTS) $(HHALIGN_LIBS)

hhfilter: hhfilter.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)
	  $(CPP) hhfilter.C -o hhfilter $(CS_OBJECTS)

hhfilter_static: hhfilter.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)
	  $(CPP) -static hhfilter.C -o hhfilter $(CS_OBJECTS) 

hhfilter_valgrind: hhfilter.C $(SOURCES) $(HEADERS)$(CS_OBJECTS)
	  $(CPP_VALGRIND) hhfilter.C -o hhfilter_valgrind $(CS_OBJECTS) 

hhconsensus: hhconsensus.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)
	     $(CPP) hhconsensus.C -o hhconsensus $(CS_OBJECTS)

hhconsensus_static: hhconsensus.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)
	     $(CPP) -static hhconsensus.C -o hhconsensus $(CS_OBJECTS)

hhconsensus_valgrind: hhconsensus.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)
	     $(CPP_VALGRIND) hhconsensus.C -o hhconsensus_valgrind $(CS_OBJECTS)

hhsuite-userguide.pdf: hhsuite-userguide.tex
	pdflatex hhsuite-userguide.tex
	bibtex hhsuite-userguide
	pdflatex hhsuite-userguide.tex
	pdflatex hhsuite-userguide.tex
	cp hhsuite-userguide.pdf ../

clean: 	
	-rm -f *.o cs/*.o
	-rm -f hhconsensus hhconsensus_valgrind hhfilter_valgrind hhfilter hhalign_valgrind hhalign hhmake hhblits_valgrind hhblits hhsearch_valgrind hhsearch cstranslate

=== lib/ffindex/src/Makefile ===
INSTALL_DIR?=..
libdir=`([ -d /usr/lib64 ] && echo lib64) || echo lib`
LANG=C
CFLAGS+=-std=c99 -openmp -g -fPIC -Wall
ifdef FFINDEX_STATIC
	LDFLAGS+=-static
	FFINDEX_OBJECTS=libffindex.a
else
	FFINDEX_OBJECTS=libffindex.so libffindex.so.0.1 
endif

#-Wl,--version-script=libffindex.map

all: ffindex_get ffindex_build ffindex_modify libffindex.a libffindex.so

ffindex.o: ffindex.c ffindex.h ffutil.h

ffindex_get: $(FFINDEX_OBJECTS) ffindex_get.o ffindex.h
	$(CC) -o $@ ffindex_get.o $(LDFLAGS) -L. -lffindex

ffindex_build: $(FFINDEX_OBJECTS) ffindex_build.o ffindex.h
	$(CC) -o $@ ffindex_build.o $(LDFLAGS) -L. -lffindex

ffindex_modify: $(FFINDEX_OBJECTS) ffindex_modify.o ffindex.h
	$(CC) -o $@ ffindex_modify.o $(LDFLAGS) -L. -lffindex

libffindex.so.0.1: ffindex.o ffutil.o
	$(CC) -Wl,-z,defs -shared -Wl,-soname,libffindex.so.0.1 -o libffindex.so.0.1 ffindex.o ffutil.o -lc

libffindex.so: libffindex.so.0.1
	ln -sf libffindex.so.0.1 libffindex.so

libffindex.a: ffindex.o ffutil.o
	ar rcs libffindex.a ffutil.o ffindex.o 

test:
	rm -f /tmp/test.data /tmp/test.ffindex
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_build -s /tmp/test.data /tmp/test.ffindex ../test/data ../test/data2
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /tmp/test.data /tmp/test.ffindex a b foo | tee /tmp/test.out
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_modify -u /tmp/test.ffindex b
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /tmp/test.data /tmp/test.ffindex a b foo | tee /tmp/test-unlink.out
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_build -a -s /tmp/test.data /tmp/test.ffindex ../test/testfile
	@echo ======== compare results =========
	diff /tmp/test.out test.should
	diff /tmp/test-unlink.out test-unlink.should
	@echo ======== error handling ==========
	@echo
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /tmp/test.data /tmp/test.ffindex nonexistquery b foo || echo
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /nonexist/data /tmp/test.ffindex a foo || echo
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /tmp/test.data /nonexist/index a foo || echo

time:
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" zsh -c "time ./ffindex_get  ../test_big/nr20_11Jan10_a3m_db ../test_big/nr20_11Jan10_a3m_db.ffindex BABBAMIBA.a3m KARDUZEBA.a3m HARPAQIBA.a3m WOQQATEBA.a3m BEBRAQIBA.a3m GIRSAKEBA.a3m NAQTIFIBA.a3m BIWCIQABA.a3m > /dev/null"

clean:
	rm -f ffindex.o ffutil.o ffindex_build ffindex_build.o ffindex_get ffindex_get.o libffindex.so libffindex.so.0.1 ffindex_modify ffindex_modify.o libffindex.a

install:
	mkdir -p $(INSTALL_DIR)/bin
	mkdir -p $(INSTALL_DIR)/$(libdir)
	mkdir -p $(INSTALL_DIR)/include
	install ffindex_get $(INSTALL_DIR)/bin/ffindex_get
	install ffindex_build $(INSTALL_DIR)/bin/ffindex_build
	install ffindex_modify $(INSTALL_DIR)/bin/ffindex_modify
	install libffindex.so.0.1 $(INSTALL_DIR)/$(libdir)/libffindex.so.0.1
	install libffindex.a $(INSTALL_DIR)/$(libdir)/libffindex.a
	ln -sf libffindex.so.0.1 $(INSTALL_DIR)/$(libdir)/libffindex.so
	install ffindex.h $(INSTALL_DIR)/include/ffindex.h
	install ffutil.h $(INSTALL_DIR)/include/ffutil.h

deinstall:
	rm -f $(INSTALL_DIR)/bin/ffindex_get $(INSTALL_DIR)/bin/ffindex_build $(INSTALL_DIR)/bin/ffindex_modify \
		$(INSTALL_DIR)/$(libdir)/libffindex.so.0.1 $(INSTALL_DIR)/$(libdir)/libffindex.a \
		$(INSTALL_DIR)/$(libdir)/libffindex.so $(INSTALL_DIR)/include/ffindex.h $(INSTALL_DIR)/include/ffutil.h
	rmdir $(INSTALL_DIR)/bin || true
	rmdir $(INSTALL_DIR)/$(libdir) || true
	rmdir $(INSTALL_DIR)/include || true

=== debian/changelog ===
hhsuite (2.0.13-1) unstable; urgency=low

  * New upstream release

 -- Laszlo Kajan <lkajan@rostlab.org>  Wed, 07 Mar 2012 09:35:48 +0100

hhsuite (2.0.12-1) unstable; urgency=low

  * Initial release (Closes: #656626)

 -- Laszlo Kajan <lkajan@rostlab.org>  Wed, 22 Feb 2012 10:03:00 +0100

=== debian/control ===
Source: hhsuite
Section: science
Priority: extra
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Laszlo Kajan <lkajan@rostlab.org>
Build-Depends: debhelper (>= 8.0.0), libffindex0-dev, help2man, libpng12-dev
Standards-Version: 3.9.3
Homepage: http://toolkit.genzentrum.lmu.de/sections/search
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/hhsuite/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/hhsuite/trunk/
DM-Upload-Allowed: yes

Package: hhsuite
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, ffindex, hhsuite-data
Description: sensitive protein sequence searching based on HMM-HMM alignment
 HH-suite is an open-source software package for sensitive protein sequence
 searching based on the pairwise alignment of hidden Markov models (HMMs).
 .
 This package contains HHsearch and HHblits among other programs and utilities.
 .
 HHsearch takes as input a multiple sequence alignment (MSA) or profile HMM
 and searches a database of HMMs (e.g. PDB, Pfam, or InterPro) for homologous
 proteins. HHsearch is often used for protein structure prediction to detect
 homologous templates and to build highly accurate query-template pairwise
 alignments for homology modeling.
 .
 HHblits can build high-quality MSAs starting from single sequences or from
 MSAs. It transforms these into a query HMM and, using an iterative search
 strategy, adds significantly similar sequences from the previous search to
 the updated query HMM for the next search iteration. Compared to PSI-BLAST,
 HHblits is faster, up to twice as sensitive and produces more accurate
 alignments.

Package: hhsuite-data
Architecture: all
Depends: ${misc:Depends}
Description: sensitive protein sequence searching based on HMM-HMM alignment (data)
 HH-suite is an open-source software package for sensitive protein sequence
 searching based on the pairwise alignment of hidden Markov models (HMMs).
 .
 This package contains architecture independent scripts and data files.

Package: hhsuite-dbg
Architecture: amd64
Section: debug
Depends: hhsuite (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: sensitive protein sequence searching based on HMM-HMM alignment (debug)
 HH-suite is an open-source software package for sensitive protein sequence
 searching based on the pairwise alignment of hidden Markov models (HMMs).
 .
 This package contains the debugging symbols.

## hhsuite 2.0.15

=== Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 INSTALL_DATA_DIR?=$(INSTALL_LIB_DIR)/data
 INSTALL_LIB_BIN_DIR?=$(INSTALL_LIB_DIR)/bin
 
-dist_name=hhsuite-2.0.13
+dist_name=hhsuite-2.0.15
 
 .PHONY: all_static
 all_static: ffindex_static

=== src/Makefile ===
--- 
+++ 
@@ -76,10 +76,10 @@
 $(CS_OBJECTS): $(CS_DIR)/%.o: $(CS_DIR)/%.cc
 	$(CPP) $(OBJECT_LIBS) -c $< -o $@
 
-cstranslate: $(CS_DIR)/cstranslate_app.cc $(CS_OBJECTS)
+cstranslate: $(CS_DIR)/cstranslate_app.cc $(CS_DIR)/*.cc $(CS_DIR)/*.h $(CS_OBJECTS)
 	$(CPP) -lm -o cstranslate $(CS_DIR)/cstranslate_app.cc $(CS_OBJECTS)
 
-cstranslate_static: $(CS_DIR)/cstranslate_app.cc $(CS_OBJECTS)
+cstranslate_static: $(CS_DIR)/cstranslate_app.cc $(CS_DIR)/*.cc $(CS_DIR)/*.h $(CS_OBJECTS)
 	$(CPP) -static -lm -o cstranslate $(CS_DIR)/cstranslate_app.cc $(CS_OBJECTS)
 
 hhsearch: hhsearch.C $(SOURCES) $(HEADERS) $(CS_OBJECTS)

=== debian/changelog ===
hhsuite (2.0.15-1) unstable; urgency=low

  * New upstream release.

 -- Laszlo Kajan <lkajan@rostlab.org>  Wed, 27 Jun 2012 14:17:05 +0200

hhsuite (2.0.14-1) unstable; urgency=low

  * [Andreas Tille <tille@debian.org>]
    debian/upstream: Enhanced author values
  * [Laszlo Kajan <lkajan@rostlab.org>]
    New upstream release.

 -- Laszlo Kajan <lkajan@rostlab.org>  Wed, 23 May 2012 10:52:40 +0200

hhsuite (2.0.13-2) unstable; urgency=low

  * [Andreas Tille <tille@debian.org>]
    debian/upstream:
     - it is (now) possible to support more than one citation
     - more verbose citation information
  * [Laszlo Kajan <lkajan@rostlab.org]
    Added #include <unistd.h> to src/hhsearch.C in order to fix compilation
    issue with g++-4.7. (Closes: #667201)

 -- Laszlo Kajan <lkajan@rostlab.org>  Wed, 04 Apr 2012 13:45:49 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Laszlo Kajan <lkajan@rostlab.org>
-Build-Depends: debhelper (>= 8.0.0), libffindex0-dev, help2man, libpng12-dev
+Build-Depends: debhelper (>= 8.0.0), libffindex0-dev (>= 0.9.6.1), help2man, libpng12-dev
 Standards-Version: 3.9.3
 Homepage: http://toolkit.genzentrum.lmu.de/sections/search
 Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/hhsuite/trunk/
@@ -12,7 +12,8 @@
 
 Package: hhsuite
 Architecture: amd64
-Depends: ${shlibs:Depends}, ${misc:Depends}, ffindex, hhsuite-data
+Depends: ${shlibs:Depends}, ${misc:Depends}, ffindex (>= 0.9.6.1),
+ hhsuite-data (= ${source:Version})
 Description: sensitive protein sequence searching based on HMM-HMM alignment
  HH-suite is an open-source software package for sensitive protein sequence
  searching based on the pairwise alignment of hidden Markov models (HMMs).

=== debian/watch ===
version=3

ftp://toolkit.lmb.uni-muenchen.de/HH-suite/releases/hhsuite-([0-9.]+)\.tar\.gz debian uupdate

## hhsuite 2.0.16

=== Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 INSTALL_DATA_DIR?=$(INSTALL_LIB_DIR)/data
 INSTALL_LIB_BIN_DIR?=$(INSTALL_LIB_DIR)/bin
 
-dist_name=hhsuite-2.0.15
+dist_name=hhsuite-2.0.16
 
 .PHONY: all_static
 all_static: ffindex_static

=== src/Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
   OBJECT_LIBS = -openmp
 else # ifndef ICC
   CXX = g++
-  CXXFLAGS = -O3 -Wall -Wno-deprecated -Wno-char-subscripts -fno-strict-aliasing -I$(CS_DIR) $(BITS_FLAG) -I$(FFINDEX_DIR)
+  CXXFLAGS = -O3 -Wall -Wno-deprecated -Wno-char-subscripts -fno-strict-aliasing -I$(CS_DIR) $(BITS_FLAG) -I$(FFINDEX_DIR) -fopenmp
   HHSEARCH_LIBS = -lpthread
   HHBLITS_LIBS = -lpthread -fopenmp
   HHALIGN_LIBS =

=== lib/ffindex/Makefile ===
OS:= $(shell uname)

ifeq ($(OS), Darwin)
MFILE=Makefile.osx
else
MFILE=Makefile
endif

all:
	$(MAKE) -C src -f $(MFILE) $@

%:
	$(MAKE) -C src -f $(MFILE) $@

release:
	hg archive -t tgz ffindex-`cat VERSION`.tar.gz

=== lib/ffindex/src/Makefile ===
--- 
+++ 
@@ -1,7 +1,10 @@
 INSTALL_DIR?=..
 libdir=`([ -d /usr/lib64 ] && echo lib64) || echo lib`
 LANG=C
-CFLAGS+=-std=c99 -openmp -g -fPIC -Wall
+CC=gcc -fopenmp
+#CC=icc -openmp
+CFLAGS+=-std=c99 -O2 -g -fPIC -Wall -pedantic
+LDFLAGS=-lffindex -L.
 ifdef FFINDEX_STATIC
 	LDFLAGS+=-static
 	FFINDEX_OBJECTS=libffindex.a
@@ -11,9 +14,26 @@
 
 #-Wl,--version-script=libffindex.map
 
-all: ffindex_get ffindex_build ffindex_modify libffindex.a libffindex.so
+OBJECTS=ffindex_apply ffindex_from_fasta ffindex_get ffindex_build ffindex_modify libffindex.a libffindex.so ffindex_unpack
+
+ifdef HAVE_MPI
+OBJECTS+=ffindex_apply_mpi
+endif
+
+all: $(OBJECTS)
 
 ffindex.o: ffindex.c ffindex.h ffutil.h
+
+ffindex_apply: $(FFINDEX_OBJECTS) ffindex_apply.o ffindex.h
+
+ffindex_apply_mpi: $(FFINDEX_OBJECTS) ffindex_apply_mpi.o ffindex.h
+	mpicc $(CFLAGS) -o $@  ffindex_apply_mpi.o $(LDFLAGS)
+
+ffindex_apply_mpi.o: ffindex_apply_mpi.c ffindex.h
+	mpicc $(CFLAGS) -c ffindex_apply_mpi.c -o $@ 
+
+ffindex_from_fasta: $(FFINDEX_OBJECTS) ffindex_from_fasta.o ffindex.h
+	$(CC) -o $@ ffindex_from_fasta.o $(LDFLAGS) -L. -lffindex
 
 ffindex_get: $(FFINDEX_OBJECTS) ffindex_get.o ffindex.h
 	$(CC) -o $@ ffindex_get.o $(LDFLAGS) -L. -lffindex
@@ -23,6 +43,9 @@
 
 ffindex_modify: $(FFINDEX_OBJECTS) ffindex_modify.o ffindex.h
 	$(CC) -o $@ ffindex_modify.o $(LDFLAGS) -L. -lffindex
+
+ffindex_unpack: $(FFINDEX_OBJECTS) ffindex_unpack.o ffindex.h
+	$(CC) -o $@ ffindex_unpack.o $(LDFLAGS) -L. -lffindex
 
 libffindex.so.0.1: ffindex.o ffutil.o
 	$(CC) -Wl,-z,defs -shared -Wl,-soname,libffindex.so.0.1 -o libffindex.so.0.1 ffindex.o ffutil.o -lc
@@ -53,7 +76,8 @@
 	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" zsh -c "time ./ffindex_get  ../test_big/nr20_11Jan10_a3m_db ../test_big/nr20_11Jan10_a3m_db.ffindex BABBAMIBA.a3m KARDUZEBA.a3m HARPAQIBA.a3m WOQQATEBA.a3m BEBRAQIBA.a3m GIRSAKEBA.a3m NAQTIFIBA.a3m BIWCIQABA.a3m > /dev/null"
 
 clean:
-	rm -f ffindex.o ffutil.o ffindex_build ffindex_build.o ffindex_get ffindex_get.o libffindex.so libffindex.so.0.1 ffindex_modify ffindex_modify.o libffindex.a
+	rm -f ffindex.o ffutil.o ffindex_build ffindex_build.o ffindex_get ffindex_get.o libffindex.so libffindex.so.0.1 ffindex_modify ffindex_modify.o \
+		libffindex.a  ffindex_from_fasta.o ffindex_from_fasta ffindex_apply_mpi.o ffindex_apply.o
 
 install:
 	mkdir -p $(INSTALL_DIR)/bin
@@ -62,16 +86,23 @@
 	install ffindex_get $(INSTALL_DIR)/bin/ffindex_get
 	install ffindex_build $(INSTALL_DIR)/bin/ffindex_build
 	install ffindex_modify $(INSTALL_DIR)/bin/ffindex_modify
+	install ffindex_from_fasta $(INSTALL_DIR)/bin/ffindex_from_fasta
+	install ffindex_apply $(INSTALL_DIR)/bin/ffindex_apply
+	install ffindex_unpack $(INSTALL_DIR)/bin/ffindex_unpack
 	install libffindex.so.0.1 $(INSTALL_DIR)/$(libdir)/libffindex.so.0.1
 	install libffindex.a $(INSTALL_DIR)/$(libdir)/libffindex.a
 	ln -sf libffindex.so.0.1 $(INSTALL_DIR)/$(libdir)/libffindex.so
 	install ffindex.h $(INSTALL_DIR)/include/ffindex.h
 	install ffutil.h $(INSTALL_DIR)/include/ffutil.h
+ifdef HAVE_MPI
+	install ffindex_apply_mpi $(INSTALL_DIR)/bin/ffindex_apply_mpi
+endif
 
 deinstall:
 	rm -f $(INSTALL_DIR)/bin/ffindex_get $(INSTALL_DIR)/bin/ffindex_build $(INSTALL_DIR)/bin/ffindex_modify \
 		$(INSTALL_DIR)/$(libdir)/libffindex.so.0.1 $(INSTALL_DIR)/$(libdir)/libffindex.a \
-		$(INSTALL_DIR)/$(libdir)/libffindex.so $(INSTALL_DIR)/include/ffindex.h $(INSTALL_DIR)/include/ffutil.h
+		$(INSTALL_DIR)/$(libdir)/libffindex.so $(INSTALL_DIR)/include/ffindex.h $(INSTALL_DIR)/include/ffutil.h\
+		$(INSTALL_DIR)/bin/ffindex_from_fasta
 	rmdir $(INSTALL_DIR)/bin || true
 	rmdir $(INSTALL_DIR)/$(libdir) || true
 	rmdir $(INSTALL_DIR)/include || true

=== debian/changelog ===
hhsuite (2.0.16-6) unstable; urgency=medium

  * Versioned Build-Depends ffindex0-dev (>= 0.9.9.6-2)
    Closes: #802076

 -- Andreas Tille <tille@debian.org>  Sun, 18 Oct 2015 07:53:08 +0200

hhsuite (2.0.16-5) unstable; urgency=medium

  * Add Replaces: hhsuite which was missing as well

 -- Andreas Tille <tille@debian.org>  Fri, 07 Nov 2014 07:08:34 +0100

hhsuite (2.0.16-4) unstable; urgency=medium

  * Add missing Breaks statement for hhsuite-doc
    Closes: #768114

 -- Andreas Tille <tille@debian.org>  Wed, 05 Nov 2014 07:21:05 +0100

hhsuite (2.0.16-3) unstable; urgency=medium

  * hhsuite Breaks hhsuite-data (<= 2.0.16-1)
    Closes: #765066
  * Priority: optional
  * Debhelper 9
  * cme fix dpkg-control
  * DEP5 fix
  * *-doc and *-data package are Architecture: all

 -- Andreas Tille <tille@debian.org>  Mon, 13 Oct 2014 14:44:05 +0200

hhsuite (2.0.16-2) unstable; urgency=low

  [Steffen Moeller]
  * Bumped standard to 3.9.4.
  * Removed DMUA flag.
  * Created new -doc package and moved user guide to it
  * Moved scripts directory from hhsuite-data to hhsuite
  * Added CHANGES file to .docs
  * joined hardening patch with rest1

  [Laszlo Kajan]
  * Bumped standard to 3.9.5.
  * Pulled 2.0.16-1 -> 2.0.16-1u1 changes from Ubuntu: arch all packages are
    now amd64, since all arch dep packages are also amd64.
  * Completed Steffen's changes.
  * Removed libpng12-dev dependency by disabling png feature. (Closes: #742579)

 -- Laszlo Kajan <lkajan@debian.org>  Mon, 08 Sep 2014 19:32:43 +0200

hhsuite (2.0.16-1) unstable; urgency=low

  [Laszlo Kajan]
  * New upstream release.
  * Updated debian/watch file.

 -- Laszlo Kajan <lkajan@rostlab.org>  Mon, 24 Sep 2012 09:32:14 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,24 @@
 Source: hhsuite
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders: Laszlo Kajan <lkajan@debian.org>,
+           Andreas Tille <tille@debian.org>
 Section: science
-Priority: extra
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Laszlo Kajan <lkajan@rostlab.org>
-Build-Depends: debhelper (>= 8.0.0), libffindex0-dev (>= 0.9.6.1), help2man, libpng12-dev
-Standards-Version: 3.9.3
+Priority: optional
+Build-Depends: debhelper (>= 9),
+               libffindex0-dev (>= 0.9.9.6-2),
+               help2man
+Standards-Version: 3.9.6
+Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/hhsuite/trunk/
+Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/hhsuite/trunk/
 Homepage: http://toolkit.genzentrum.lmu.de/sections/search
-Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/hhsuite/trunk/
-Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/hhsuite/trunk/
-DM-Upload-Allowed: yes
 
 Package: hhsuite
 Architecture: amd64
-Depends: ${shlibs:Depends}, ${misc:Depends}, ffindex (>= 0.9.6.1),
- hhsuite-data (= ${source:Version})
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         ffindex (>= 0.9.6.1),
+         hhsuite-data (= ${source:Version})
+Breaks: hhsuite-data (<= 2.0.16-1)
 Description: sensitive protein sequence searching based on HMM-HMM alignment
  HH-suite is an open-source software package for sensitive protein sequence
  searching based on the pairwise alignment of hidden Markov models (HMMs).
@@ -33,6 +38,20 @@
  HHblits is faster, up to twice as sensitive and produces more accurate
  alignments.
 
+Package: hhsuite-doc
+Architecture: all
+Section: doc
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
+Recommends: hhsuite
+Breaks: hhsuite (<= 2.0.16-1)
+Replaces: hhsuite (<= 2.0.16-1)
+Description: documentation for HHsuite for HMM-HMM comparisons
+ HH-suite is an open-source software package for sensitive protein sequence
+ searching based on the pairwise alignment of hidden Markov models (HMMs).
+ .
+ This package provides a PDF with the user guide for HH-suite.
+
 Package: hhsuite-data
 Architecture: all
 Depends: ${misc:Depends}
@@ -45,7 +64,10 @@
 Package: hhsuite-dbg
 Architecture: amd64
 Section: debug
-Depends: hhsuite (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Priority: extra
+Depends: hhsuite (= ${binary:Version}),
+         ${shlibs:Depends},
+         ${misc:Depends}
 Description: sensitive protein sequence searching based on HMM-HMM alignment (debug)
  HH-suite is an open-source software package for sensitive protein sequence
  searching based on the pairwise alignment of hidden Markov models (HMMs).

=== debian/watch ===
version=3

opts=passive \
ftp://toolkit.lmb.uni-muenchen.de/pub/HH-suite/releases/hhsuite-([0-9.]+)\.tar\.gz debian uupdate

## hhsuite 3.0~beta2%2Bdfsg

=== scripts/CMakeLists.txt ===

INSTALL(PROGRAMS
	Align.pm  
	HHPaths.pm  
	PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
	DESTINATION scripts
)


INSTALL(PROGRAMS 
	addss.pl  
	create_profile_from_hhm.pl	
	hhmakemodel.pl	
	hhsuitedb.py  
	mergeali.pl
	multithread.pl  
	pdbfilter.pl  
	renumberpdb.pl
	create_profile_from_hmmer.pl	
	pdb2fasta.pl    
	reformat.pl   
	splitfasta.pl
	check_a3m.py	  
	ffindex.py
	a3m.py
	get_a3m_size.py
	is_huge_a3m.py
	DESTINATION scripts
)

=== scripts/hhpred/dependencies/Makefile ===
all: TMalign TMscore modeller install clean

TMalign.f:
	wget http://zhanglab.ccmb.med.umich.edu/TM-align/TMalign.f

TMalign: TMalign.f
	gfortran -static -O3 -ffast-math -lm -o TMalign TMalign.f

TMscore.f:
	wget http://zhanglab.ccmb.med.umich.edu/TM-score/TMscore.f

TMscore: TMscore.f
	gfortran -static -O3 -ffast-math -lm -o TMscore TMscore.f

modeller-9.13.tar.gz:
	wget http://salilab.org/modeller/9.13/modeller-9.13.tar.gz

modeller: modeller-9.13.tar.gz
	tar xzvf modeller-9.13.tar.gz
	echo -e "3\n$(abspath $(CURDIR)/../bin/modeller9.13/)\nXXXXXXXXXX\n\n\n\n\n\n\n\n\n" > opt_modeller.opt
	mkdir -p $(abspath $(CURDIR)/../bin/modeller9.13/)
	cd modeller-9.13 && ./Install < ../opt_modeller.opt
	rm opt_modeller.opt
	-patch --forward $(abspath $(CURDIR)/../bin/modeller9.13/)/src/include/modeller.h < patch_modeller_h_missing_files.patch
	-cd modeller_cuser && ./buildall.sh $(abspath $(CURDIR)/../bin/modeller9.13/)

install:
	cp TMalign ../bin/
	cp TMscore ../bin/

clean:
	rm -f TMalign*
	rm -f TMscore*
	rm -rf modeller-9.13
	rm -f modeller-9.13.tar.gz

=== debian/changelog ===
hhsuite (3.0~beta2+dfsg-3) unstable; urgency=medium

  * Specify correct format in printf statement (Thanks for the patch to
    Daniel Shahaf <danielsh@apache.org>)
    Closes: #851764

 -- Andreas Tille <tille@debian.org>  Wed, 18 Jan 2017 16:52:21 +0100

hhsuite (3.0~beta2+dfsg-2) unstable; urgency=medium

  * Really fix watch file to fetch latest version
  * debhelper 10
  * simplify d/rules to make it more readable
  * drop -dbg file

 -- Andreas Tille <tille@debian.org>  Wed, 18 Jan 2017 12:06:40 +0100

hhsuite (3.0~beta2+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Fixed watch file

  [ Sascha Steinbiss ]
  * New upstream release.
    Closes: #846487
  * Massive rework of packaging due to new upstream code and build system.
  * Migrate to git.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 14 Jan 2017 15:23:25 +0000

hhsuite (2.0.16-7) unstable; urgency=medium

  * Use system defined log2 and log10 to enable build using gcc-6.1
    Closes: #831115
  * cme fix dpkg-control
  * fix spelling
  * hardening=+all

 -- Andreas Tille <tille@debian.org>  Sat, 13 Aug 2016 07:49:16 +0200

## hhsuite 3.0~beta2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(hhsuite CXX)

SET(HAVE_SSSE3 0 CACHE BOOL "Have SSSE3")
SET(HAVE_AVX2 0 CACHE BOOL "Have AVX2")

#set(CMAKE_BUILD_TYPE Release)

# find compiler
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  message("-- Compiler is clang(++)")
  set(CMAKE_COMPILER_IS_CLANG 1)
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  message("-- Compiler is GNU ")
  set(CMAKE_COMPILER_IS_GNUCXX 1)
  set(CMAKE_COMPILER_IS_GNUCCC 1)
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
  message("-- Compiler is ICC ")
  set(CMAKE_COMPILER_IS_ICC 1)
endif()

set (HHSUITE_VERSION_MAJOR 3)
set (HHSUITE_VERSION_MINOR 0)
set (HHSUITE_VERSION_PATCH 0)
set (HHSUITE_DATE "15-03-2015")

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

INSTALL(FILES
  hhsuite-userguide.pdf
  LICENSE
  README
  PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
  DESTINATION ./
)

include_directories(src)
include_directories(lib/ffindex/src)

add_subdirectory(src)
add_subdirectory(data)
add_subdirectory(scripts)
add_subdirectory(test)
#add_subdirectory(doc)
add_subdirectory(lib/ffindex)


SET (CPACK_GENERATOR "DEB;TGZ;ZIP;RPM")
SET (CPACK_DEBIAN_PACKAGE_MAINTAINER "Markus Meier")

set(CPACK_SOURCE_IGNORE_FILES
  ".synctex.gz$"
  ".toc$"
  ".blg$"
  ".bbl$"
  ".aux$"
  ".log$"
  ".dvi$"
  ".out.ps$"
  "/rpm/"
  "^${PROJECT_SOURCE_DIR}/build/"
  "^${PROJECT_SOURCE_DIR}/.git/"
  "^${PROJECT_SOURCE_DIR}/.gitignore"
  "^${PROJECT_SOURCE_DIR}/.gitattributes"
  "^${PROJECT_SOURCE_DIR}/.gitmodules"
  "^${PROJECT_SOURCE_DIR}/.pydevproject"
  "^${PROJECT_SOURCE_DIR}/.project"
  "^${PROJECT_SOURCE_DIR}/.cproject"
  "^${PROJECT_SOURCE_DIR}/lib/ffindex/.git"
  "^${PROJECT_SOURCE_DIR}/lib/ffindex/.git"
  "^${PROJECT_SOURCE_DIR}/.autotools"
  "^${PROJECT_SOURCE_DIR}/README.md"
)

set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set (CPACK_PACKAGE_VERSION_MAJOR "${HHSUITE_VERSION_MAJOR}")
set (CPACK_PACKAGE_VERSION_MINOR "${HHSUITE_VERSION_MINOR}")
set (CPACK_PACKAGE_VERSION_MINOR "${HHSUITE_VERSION_PATCH}")
INCLUDE(CPack)

enable_testing()

=== data/CMakeLists.txt ===


INSTALL(FILES
	context_data.crf
	context_data.lib
	cs219.lib
	do_not_delete
	do_not_delete.phr
	do_not_delete.pin
	do_not_delete.psq
	PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
	DESTINATION data
)

=== doc/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.7)

include(UseLATEX.cmake)

SET(MyDocImages
  hhblits-hhsearch.png
)

ADD_LATEX_DOCUMENT(hhsuite-userguide.tex
	DEFAULT_PDF
	BIBFILES hhsuite-userguide.bib
	IMAGES ${MyDocImages}
)

#add_custom_command(TARGET pdf POST_BUILD
#	COMMAND ${CMAKE_COMMAND} -E copy
#	${CMAKE_CURRENT_BINARY_DIR}/hhsuite-userguide.pdf
#	${CMAKE_BINARY_DIR}/hhsuite-userguide.pdf
#)

=== src/CMakeLists.txt ===
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake")

#Sanitizers
if(${HAVE_SANITIZER})
	include(FindUBSan)
	include(FindASan)
	include(FindMSan)
	include(FindTSan)
endif()

#SSE
if(${HAVE_AVX2})
    ADD_DEFINITIONS("-DAVX2")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mavx2 -Wa,-q")
elseif(${HAVE_SSSE3})
    ADD_DEFINITIONS("-DSSE")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mssse3")
else()
    include(CheckSSEFeatures)
    ADD_DEFINITIONS(${CXX_DFLAGS})
    if(${HAVE_AVX2_EXTENSIONS})
        ADD_DEFINITIONS("-DAVX2")
    elseif(${HAVE_SSSE3_EXTENSIONS})
        ADD_DEFINITIONS("-DSSE")
    else()
        message( FATAL_ERROR "SSSE3 is needed to run compile! CMake will exit." )
    endif(${HAVE_AVX2_EXTENSIONS})
endif()



find_package(OpenMP)
if (OPENMP_FOUND)
	message("-- Found OpenMP")
	add_definitions(-DOPENMP)
	set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
	set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif()


set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-strict-aliasing")

add_subdirectory(cs)
include_directories(cs)
include_directories("${PROJECT_BINARY_DIR}")

set(HH_SOURCE
	${HH_SOURCE}
	${CMAKE_CURRENT_SOURCE_DIR}/hhblits.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhblits.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhdecl.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhdecl.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhhit.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhhit-inl.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhhit.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhmatrices.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhmatrices.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhsearch.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhsearch.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhalign.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhalign.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhhitlist.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhhitlist-inl.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhhitlist.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhposteriordecoder.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhposteriordecoder.cpp 
	${CMAKE_CURRENT_SOURCE_DIR}/hhutil.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhutil-inl.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhutil.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/util.h
	${CMAKE_CURRENT_SOURCE_DIR}/util.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhalignment.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhalignment.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhforwardalgorithm.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhhmm.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhhmm.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhposteriordecoderrunner.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhposteriordecoderrunner.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbialgorithm.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhfullalignment.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhfullalignment.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhhmmsimd.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhhmmsimd.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhposteriormatrix.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhposteriormatrix.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbi.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbi.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhbacktracemac.cpp 
	${CMAKE_CURRENT_SOURCE_DIR}/hhmacalgorithm.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhprefilter.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhprefilter.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbimatrix.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbimatrix-inl.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbimatrix.cpp 
	${CMAKE_CURRENT_SOURCE_DIR}/hhbackwardalgorithm.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhdatabase.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhdatabase.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhhalfalignment.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhhalfalignment.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbirunner.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbirunner.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhfunc.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhfunc.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/simd.h
)

# configure a header file to pass some of the CMake settings
# to the source code
configure_file (
  "${CMAKE_CURRENT_SOURCE_DIR}/hhsuite_config.h.in"
  "${PROJECT_BINARY_DIR}/hhsuite_config.h"
)

add_library(HH_OBJECTS OBJECT ${HH_SOURCE})

add_library(hhviterbialgorithm_with_celloff OBJECT hhviterbialgorithm.cpp)
set_property(TARGET hhviterbialgorithm_with_celloff PROPERTY COMPILE_FLAGS "-DVITERBI_CELLOFF=1")

add_library(hhviterbialgorithm_with_celloff_and_ss OBJECT hhviterbialgorithm.cpp)
set_property(TARGET hhviterbialgorithm_with_celloff_and_ss PROPERTY COMPILE_FLAGS "-DVITERBI_CELLOFF=1 -DVITERBI_SS_SCORE=1")

add_library(hhviterbialgorithm_and_ss OBJECT hhviterbialgorithm.cpp)
set_property(TARGET hhviterbialgorithm_and_ss PROPERTY COMPILE_FLAGS "-DVITERBI_SS_SCORE=1")


add_library(CS_OBJECTS OBJECT ${CS_SOURCE})

# add the executable
add_executable(hhblits 
	hhblits_app.cpp	$<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
	$<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
	$<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
	$<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
)
target_link_libraries (hhblits ffindex)
if (OPENMP_FOUND)
add_executable(hhblits_omp
  hhblits_omp.cpp $<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
  $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
)
target_link_libraries (hhblits_omp ffindex)

INSTALL(PROGRAMS 
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhblits_omp
  DESTINATION bin
)

endif()

add_executable(hhmake
  hhmake.cpp $<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
  $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
)
target_link_libraries (hhmake ffindex)

add_executable(hhfilter
  hhfilter.cpp $<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
  $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
)
target_link_libraries (hhfilter ffindex)

add_executable(hhsearch
  hhsearch_app.cpp $<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
  $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
)
target_link_libraries (hhsearch ffindex)

add_executable(hhalign
  hhalign_app.cpp $<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
  $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
)
target_link_libraries (hhalign ffindex)

add_executable(hhconsensus
  hhconsensus.cpp $<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
  $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
)
target_link_libraries (hhconsensus ffindex)


add_library(A3M_COMPRESS_OBJECT OBJECT a3m_compress.cpp)

add_executable(a3m_extract
	a3m_extract.cpp $<TARGET_OBJECTS:A3M_COMPRESS_OBJECT>
)
target_link_libraries (a3m_extract ffindex)

add_executable(a3m_reduce
  a3m_reduce.cpp $<TARGET_OBJECTS:A3M_COMPRESS_OBJECT>
)
target_link_libraries (a3m_reduce ffindex)

add_executable(a3m_database_reduce
  a3m_database_reduce.cpp $<TARGET_OBJECTS:A3M_COMPRESS_OBJECT>
)
target_link_libraries (a3m_database_reduce ffindex)

add_executable(a3m_database_extract
  a3m_database_extract.cpp $<TARGET_OBJECTS:A3M_COMPRESS_OBJECT>
)
target_link_libraries (a3m_database_extract ffindex)

add_executable(a3m_database_filter
  a3m_database_filter.cpp $<TARGET_OBJECTS:A3M_COMPRESS_OBJECT>
)
target_link_libraries (a3m_database_filter ffindex)

add_executable(cstranslate
  cs/cstranslate_app.cc
        $<TARGET_OBJECTS:CS_OBJECTS>
        $<TARGET_OBJECTS:HH_OBJECTS>
        $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
        $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
        $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
        $<TARGET_OBJECTS:A3M_COMPRESS_OBJECT>
)
target_link_libraries (cstranslate ffindex)

find_package(MPI QUIET)
if(MPI_CXX_FOUND)
    include_directories(${MPI_CXX_INCLUDE_PATH})

    add_executable(cstranslate_mpi
            cs/cstranslate_mpi_app.cc
            $<TARGET_OBJECTS:CS_OBJECTS>
            $<TARGET_OBJECTS:HH_OBJECTS>
            $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
            $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
            $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
            $<TARGET_OBJECTS:A3M_COMPRESS_OBJECT>
            )
    target_link_libraries(cstranslate_mpi ffindex mpq)
    target_link_libraries(cstranslate_mpi ${MPI_CXX_LIBRARIES})
    set_target_properties(cstranslate_mpi PROPERTIES COMPILE_FLAGS "${MPI_CXX_COMPILE_FLAGS}")
    set_target_properties(cstranslate_mpi PROPERTIES LINK_FLAGS "${MPI_CXX_LINK_FLAGS}")

    install(PROGRAMS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/cstranslate_mpi DESTINATION bin)
endif()

INSTALL(PROGRAMS 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhblits 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhmake 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhfilter 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhsearch 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhalign 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhconsensus 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/a3m_extract
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/a3m_database_reduce
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/a3m_database_extract
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/a3m_database_filter 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/cstranslate
	DESTINATION bin
)

if (OPENMP_FOUND)
INSTALL(PROGRAMS 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhblits_omp 
	DESTINATION bin
)
endif()

=== test/CMakeLists.txt ===
enable_testing()

SET (CTEST_ENVIRONMENT
  "HHLIB=${PROJECT_SOURCE_DIR}"
)

add_test(NAME hhblits COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhblits -h)
add_test(NAME hhsearch COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhsearch -h)
add_test(NAME hhalign COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhalign -h)

SET_TESTS_PROPERTIES(hhblits hhsearch hhalign
  PROPERTIES ENVIRONMENT "HHLIB=${PROJECT_SOURCE_DIR}"
)

=== src/cs/CMakeLists.txt ===
set(CS_SOURCE
	${CS_SOURCE}
	${CMAKE_CURRENT_SOURCE_DIR}/aa.cc  
	${CMAKE_CURRENT_SOURCE_DIR}/as.cc  
	${CMAKE_CURRENT_SOURCE_DIR}/assert_helpers.cc
	${CMAKE_CURRENT_SOURCE_DIR}/blosum_matrix.cc
	${CMAKE_CURRENT_SOURCE_DIR}/getopt_pp.cc
	${CMAKE_CURRENT_SOURCE_DIR}/log.cc
	${CMAKE_CURRENT_SOURCE_DIR}/application.cc
	PARENT_SCOPE
)

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,29 @@
 Source: hhsuite
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Laszlo Kajan <lkajan@debian.org>,
-           Andreas Tille <tille@debian.org>
+           Andreas Tille <tille@debian.org>,
+           Sascha Steinbiss <satta@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper (>= 9),
                libffindex0-dev (>= 0.9.9.6-2),
+               cmake,
+               texlive-latex-base,
+               texlive-latex-recommended,
+               imagemagick,
                help2man
-Standards-Version: 3.9.6
-Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/hhsuite/trunk/
-Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/hhsuite/trunk/
+Standards-Version: 3.9.8
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/hhsuite.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/hhsuite.git
 Homepage: http://toolkit.genzentrum.lmu.de/sections/search
 
 Package: hhsuite
 Architecture: amd64
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         ffindex (>= 0.9.6.1),
-         hhsuite-data (= ${source:Version})
+         ffindex,
+         hhsuite-data (= ${source:Version}),
+         python
 Breaks: hhsuite-data (<= 2.0.16-1)
 Description: sensitive protein sequence searching based on HMM-HMM alignment
  HH-suite is an open-source software package for sensitive protein sequence

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
https://github.com/soedinglab/hh-suite/releases .*/archive/v(\d[-\d.beta]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
